/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Main.java to edit this template
 */

package ChatProgramm;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.logging.*;

/**
 * Builder Class
 * @author le
 */
public class Client
{
  private static Logger lg = Logger.getLogger("netz");
  private static final int PORT = 35000; //lt. iana port > 2¹⁵
  private static final String IP = "127.0.0.1";
  
  
  public Client() throws IOException
  {
    lg.info("Client: versuche zu verbinden");
    Socket s = new Socket(IP, PORT); // ACHTUNG blockiert!
    lg.info("Client: Verbindung akzeptiert");
    
    InputStream is = s.getInputStream();
    OutputStream os = s.getOutputStream();
    
    //Umwandlung der Byteströme
    InputStreamReader isr = new InputStreamReader(is, "UTF-8");
    OutputStreamWriter osr = new OutputStreamWriter(os, "UTF-8");
    
    //Puffer
    BufferedReader in = new BufferedReader(isr);
    //BufferedWriter out = new BufferedWriter(osr);
    //besser
    PrintWriter out = new PrintWriter(osr);
    
    lg.info("Client: Streams erfolgreich initialisiert");
    lg.info("Client: sende Textnachricht");
    
    out.println("Hallo Du Server - ich bin ein Client");
    out.flush();
    
    lg.info("Client: warte auf Serverantwort");
    
    String nachricht = in.readLine(); // ACHTUNG blockiert
    lg.info("Client: Serverbestätigung erhalten");
    
    lg.info("Client: fertig");
    in.close();
    out.close();
    s.close();
  }

  /**
   * @param args the command line arguments
   */
  public static void main(String[] args) 
  {
    try
    {
      new Client();
    }
    catch (IOException ex)
    {
      Logger.getLogger(Client.class.getName()).log(Level.SEVERE, null, ex);
    }
  }
}
