/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Main.java to edit this template
 */

package ChatProgramm;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.logging.*;

/**
 * Builder Class
 * @author le
 */
public class Server
{
  private static Logger lg = Logger.getLogger("netz");
  private static final int PORT = 35000; //lt. iana port > 2¹⁵
  
  
  public Server() throws IOException
  {
    ServerSocket sSocket = new ServerSocket(PORT);
    lg.info("Server: warte auf Verbindung");
    Socket s = sSocket.accept(); // ACHTUNG blockiert!
    
    lg.info("Server: Verbindung akzeptiert");
    
    InputStream is = s.getInputStream();
    OutputStream os = s.getOutputStream();
    
    //Umwandlung der Byteströme
    InputStreamReader isr = new InputStreamReader(is, "UTF-8");
    OutputStreamWriter osr = new OutputStreamWriter(os, "UTF-8");
    
    //Puffer
    BufferedReader in = new BufferedReader(isr);
    //BufferedWriter out = new BufferedWriter(osr);
    //besser
    PrintWriter out = new PrintWriter(osr);
    
    lg.info("Server: Streams erfolgreich initialisiert");
    lg.info("Server: warte auf Textnachricht");
    
    String nachricht = in.readLine(); // ACHTUNG blockiert
    lg.info("Server: Nachricht erhalten");
    System.out.println("Server: NACHRICHT = " + nachricht);
    
    // ACHTUNG: blockiert NICHT!!!!
    out.println("Server an Client: Nachricht erhalten");
    out.flush(); // wichtig
    
    lg.info("Server: fertig");
    in.close();
    out.close();
    s.close();
  }

  /**
   * @param args the command line arguments
   */
  public static void main(String[] args) 
  {
    try
    {
      new Server();
    }
    catch (IOException ex)
    {
      Logger.getLogger(Server.class.getName()).log(Level.SEVERE, null, ex);
    }
  }
}
